#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define double long double

const int max_n = 1e6;
int n, m, c;
double x[max_n + 2], t[max_n + 2], dp[max_n + 2];
int q[max_n + 2], dsu_left[max_n + 2];

double find_x(int j1, int j2) {
    double cc = dp[j1] - dp[j2];
    double x1 = x[j1], x2 = x[j2];
    // cc + (x - x1) * (x - x1) = (x - x2) * (x - x2)
    // cc + x1^2 - x2^2 = 2 (x1 - x2) x
    return (x1 * x1 - x2 * x2 + cc * c) / ((double) 2.0 * (x1 - x2)) ;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);

    cin >> n >> m >> c;
    for (int i = 0; i < n + 2; ++i) {
        q[i] = dsu_left[i] = -1;
        dp[i] = 1e18;
    }

    x[0] = 0.0;
    t[0] = 0.0;
    dp[0] = 0.0;

    priority_queue<pair<double, pair<int, int> >, vector<pair<double, pair<int, int> > >, greater<pair<double, pair<int, int> > > > pq; // event: x, (j, i)

    int ql = 0, qr = 0;
    q[qr++] = 0;
    dsu_left[qr - 1] = qr - 1;

    for (int i = 1; i < n + 2; ++i) {
        // cout << "count " << i << endl;
        if (i <= n) {
            cin >> x[i] >> t[i];
        } else {
            x[i] = m;
            t[i] = 0.0;
        }

        int j = q[ql];
        while (j == -1) {
            j = q[++ql];
        }
        if (ql == qr)
            return 1;
        dp[i] = dp[j] + (x[i] - x[j]) * (x[i] - x[j]) / c + t[i];
        while (!pq.empty() && pq.top().first <= x[i]) {
            // do event
            auto [l, r] = pq.top().second;
            double xc = pq.top().first;
            // cout << "del " << xc << ": " << q[l] << ' ' << q[r] << endl;
            pq.pop();

            if (q[l] == -1 || q[r] == -1 || abs(dp[q[l]] + (xc - x[q[l]]) * (xc - x[q[l]]) / c - dp[q[r]] - (xc - x[q[r]]) * (xc - x[q[r]]) / c) > 1e-6) {
                // cout << "ignore " << abs(dp[q[l]] + (xc - x[q[l]]) * (xc - x[q[l]]) / c - dp[q[r]] - (xc - x[q[r]]) * (xc - x[q[r]]) / c) << endl;
                continue;
            }

            q[l] = -1;
            dsu_left[l] = l > 0 ? dsu_left[l - 1] : -1;
            while (dsu_left[l] != -1 && q[dsu_left[l]] == -1) {
                dsu_left[l] = dsu_left[dsu_left[l]];
            }

            if (dsu_left[l] != -1) {
                double x = find_x(q[dsu_left[l]], q[r]);
                // cout << "check " << x << ": " << q[dsu_left[l]] << ' ' << q[r] << endl;
                if (x <= m) {
                    // cout << "add" << endl;
                    pq.push({x, {dsu_left[l], r}});
                } else {
                    // cout << "no add" << endl;
                }
            }

            j = q[ql];
            while (j == -1) {
                j = q[++ql];
            }
            if (ql == qr)
                return 1;
            dp[i] = dp[j] + (x[i] - x[j]) * (x[i] - x[j]) / c + t[i];
        }
        /* for (int j = 0; j < i; ++j) {
            dp[i] = min(dp[i], dp[j] + (x[i] - x[j]) * (x[i] - x[j]) / c + t[i]);
        }*/
        // cout << i << ": " << dp[i] << endl;

        while (ql < qr) {
            int j = q[qr - 1];
            if (j == -1 || dp[j] + (x[i] + 1.0 - x[j]) * (x[i] + 1.0 - x[j]) / c >= dp[i] + 1.0 / c) {
                --qr;
                // cout << "del better " << i << ": " << q[qr] << endl;
                if (q[qr] != -1) {
                    q[qr] = -1;
                    dsu_left[qr] = qr > 0 ? dsu_left[qr - 1] : -1;
                    while (dsu_left[qr] != -1 && q[dsu_left[qr]] == -1) {
                        dsu_left[qr] = dsu_left[dsu_left[qr]];
                    }
                }
            } else
                break;
        }
        q[qr++] = i;
        dsu_left[qr - 1] = qr - 1;
        // cout << "q: " << ql << ' ' << qr << endl;
        if (qr - ql >= 2) {
            while (dsu_left[qr - 2] != -1 && q[dsu_left[qr - 2]] == -1) {
                dsu_left[qr - 2] = dsu_left[dsu_left[qr - 2]];
            }
            if (dsu_left[qr - 2] != -1) {
                double x = find_x(q[dsu_left[qr - 2]], q[qr - 1]);
                // cout << "check " << x << ": " << q[dsu_left[qr - 2]] << ' ' << q[qr - 1] << endl;
                if (x <= m) {
                    // cout << "add" << endl;
                    pq.push({x, {dsu_left[qr - 2], qr - 1}});
                } else {
                    // cout << "no add" << endl;
                }
            }
        }
    }

    cout << dp[n + 1] << '\n';

    return 0;
}
