// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x...) std::cerr << "[DEBUG]\t" << __LINE__ << ":\t" << (#x) << " = "; print_debug(x)
#else
    #define debug(x...) 238
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(nullptr)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T1, typename T2>
std::ostream& operator<<(std::ostream& out, const std::pair<T1, T2>& p) {
    out << "(" << p.first << ", " << p.second << ")";
    return out;
}

template<size_t index, typename T>
std::ostream& print_tuple(std::ostream& out, const T& t) {
    if constexpr (index == std::tuple_size<T>::value) {
        out << ")";
        return out;
    } else {
        if (index > 0) {
            out << ", ";
        } else {
            out << "(";
        }
        out << std::get<index>(t);
        return print_tuple<index + 1, T>(out, t);
    }
}

template<typename ...T>
std::ostream& operator<<(std::ostream& out, const std::tuple<T...>& t) {
    return print_tuple<0, std::tuple<T...>>(out, t);
}

template<typename Container, typename = decltype(std::begin(std::declval<Container>()))>
typename std::enable_if<!std::is_same<Container, std::string>::value, std::ostream&>::type
operator<<(std::ostream& out, const Container& container) {
    out << "{";
    for (auto it = container.begin(); it != container.end(); ++it) {
        if (it != container.begin()) {
            out << ", ";
        }
        out << *it;
    }
    out << "}";
    return out;
}

void print_debug() {
    std::cerr << std::endl;
}

template<typename T, typename... V>
void print_debug(const T& value, const V&... others) {
    std::cerr << value;
    if (sizeof...(others) != 0) {
        std::cerr << ", ";
        print_debug(others...);
    } else {
        std::cerr << std::endl;
    }
}

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 2000100;

struct line {
  ll k, b;
  ll apply(ll x) const {
    return k * x + b;
  }
};
//  first x0: y(x0) < x(x0)
ll inter(line x, line y) {
  assert(y.k < x.k);
  auto point = (y.b - x.b) / (x.k - y.k);
  while (x.apply(point) <= y.apply(point)) ++point;
  while (y.apply(point - 1) < x.apply(point - 1)) --point;
  return point;
}
//  slopes are non-increasing
struct cht_min {
  ll const INF = 2e18;
  std::vector<std::pair<line, ll>> lines;
  void add_line(line const& l) {
    if (!lines.empty() && lines.back().first.k == l.k) {
      if (lines.back().first.b <= l.b) return;
      lines.pop_back();
      if (!lines.empty()) {
        lines.back().second = INF;
      }
    }
    while (lines.size() >= 2) {
      auto x_my = inter(lines.back().first, l);
      auto x_they = inter(lines[lines.size() - 2].first, lines.back().first);
      if (x_my <= x_they) {
        lines.pop_back();
      } else {
        break;
      }
    }
    if (lines.empty()) {
      lines.emplace_back(l, INF);
    } else {
      auto x = inter(lines.back().first, l);
      lines.back().second = x;
      lines.emplace_back(l, INF);
    }
  }
  ll query(ll x) const {
    return upper_bound(lines.begin(), lines.end(), x, [](ll a, auto b) {
      return a < b.second;
    })->first.apply(x);
  }
  //  <x, y>: f(x) <= y, x -> min
  std::pair<ll, ll> findFirst(ll y) const {
    int left = -1;
    int right = int(lines.size());
    while (left + 1 != right) {
      int middle = (left + right) / 2;
      auto value = lines[middle].first.apply(lines[middle].second - 1);
      if (value <= y) {
        right = middle;
      } else {
        left = middle;
      }
    }
    auto l = lines[right].first;
    auto point = (y - l.b) / l.k;
    while (l.apply(point) > y) ++point;
    while (l.apply(point - 1) <= y) --point;
    return std::make_pair(point, l.apply(point));
  }
};

int x[N], t[N];
ll dp[N];

void run() {
    int n, m, c;
    scanf("%d%d%d", &n, &m, &c);

    for (int i = 1; i <= n; ++i) {
        scanf("%d%d", &x[i], &t[i]);
    }
    x[n + 1] = m;

    cht_min cht;
    cht.add_line(line{0, 0});

    for (int i = 1; i <= n + 1; ++i) {
        dp[i] += 1ll * t[i] * c;
        dp[i] += 1ll * x[i] * x[i];
        dp[i] += cht.query(x[i]);
        cht.add_line(line{-2ll * x[i], dp[i] + 1ll * x[i] * x[i]});
    }

    printf("%.10lf\n", (double)dp[n + 1] / (double)c);
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    #ifdef PERVEEVM_LOCAL
        auto start = std::chrono::high_resolution_clock::now();
    #endif

    run();

    #ifdef PERVEEVM_LOCAL
        auto end = std::chrono::high_resolution_clock::now();
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
