#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solveTest() {
  int n, m, k;
  cin >> n >> m >> k;
  vector<int> p(n);
  for (int& x : p) {
    cin >> x;
    --x;
  }
  vector<int> posP(n);
  for (int i = 0; i < n; ++i) {
    posP[p[i]] = i;
  }
  vector<int> a(m);
  for (int& x : a) {
    cin >> x;
    --x;
    if (x >= 0) {
      x = posP[x];
    }
  }

  int const INF = int(1e9);
  vector<int> minEnd(m, INF);
  for (int i = 0; i < m; ++i) {
    if (a[i] == 0) {
      int j = i;
      while (j < m && a[j] == j - i) {
        ++j;
      }
      if (j - i == n) {
        minEnd[i] = j;
      }
    }
  }
  for (int i = m - 2; i >= 0; --i) {
    minEnd[i] = min(minEnd[i], minEnd[i + 1]);
  }
  vector<int> lenMatch(m);
  for (int i = m - 1; i >= 0; --i) {
    if (a[i] < 0) {
      lenMatch[i] = 0;
    } else {
      lenMatch[i] = 1;
      if (i + 1 < m && a[i + 1] == a[i] + 1) {
        lenMatch[i] += lenMatch[i + 1];
      }
    }
  }
  vector<int> lenMatchLeft(m);
  for (int i = 0; i < m; ++i) {
    if (a[i] < 0) {
      lenMatchLeft[i] = 0;
    } else {
      lenMatchLeft[i] = 1;
      if (i - 1 >= 0 && a[i - 1] == a[i] - 1 && a[i - 1] >= 0) {
        lenMatchLeft[i] += lenMatchLeft[i - 1];
      }
    }
  }

  struct edge {
    int to;
    int id;
  };
  vector<vector<edge>> graph(n + 1);
  auto addEdge = [&](int from, int to, int id) {
    assert(from != 0 || to != n);
    graph[from].push_back({to, id});
  };
  vector<pair<int, int>> ranges(k);
  for (auto& [l, r] : ranges) {
    cin >> l >> r;
    --l;
  }
  for (int it = 0; it < k; ++it) {
    auto[l, r] = ranges[it];
    if (minEnd[l] <= r) {
      cout << 1 << "\n";
      cout << it + 1 << "\n";
      return;
    }

    //  check substring
    int len = r - l;
    assert(len > 0);
    if (lenMatch[l] >= len) {
      addEdge(a[l], a[r - 1] + 1, it);
      continue;
    }
      
    //  check suffix  
    if (a[l] >= 0 && lenMatch[l] >= n - a[l]) {
      addEdge(a[l], n, it);
    }
    
    //  check prefix
    if (a[r - 1] >= 0 && lenMatchLeft[r - 1] >= a[r - 1]) {
      addEdge(0, a[r - 1] + 1, it);
    }
  }
  struct DP {
    int mn = INF;
    int whoMn = -1;
    int mn2 = INF;

    DP operator+(DP const& other) const {
      DP newDP{};
      if (mn < other.mn) {
        newDP.mn = mn;
        newDP.whoMn = whoMn;
        newDP.mn2 = min(mn2, other.getVal(whoMn));
      } else {
        newDP.mn = other.mn;
        newDP.whoMn = other.whoMn;
        newDP.mn2 = min(other.mn2, getVal(other.whoMn));
      }
      return newDP;
    }

    DP inc() const {
      return {mn + 1, whoMn, mn2 + 1};
    }

    int getVal(int ban) const {
      return ban == whoMn ? mn2 : mn;
    }
  };
  vector<DP> dp(n + 1);
  for (int u = n - 1; u >= 0; --u) {
    for (auto[v, i] : graph[u]) {
      if (v == n) {
        dp[u] = dp[u] + DP{1, i, INF};
      } else {
        dp[u] = dp[u] + dp[v].inc();
      }
    }
  }
  int ans = INF;
  pair<int, int> whoFirst{-1, -1};
  for (auto[s, i] : graph[0]) {
    assert(s < n);
    auto dpS = dp[s];
    int val = 1 + dpS.getVal(i);
    if (val < ans) {
      ans = val;
      whoFirst = {s, i};
    }
  }
  if (ans == INF) {
    cout << -1 << "\n";
    return;
  }
  assert(ans >= 2);
  cout << ans << "\n";
  vector<int> path{whoFirst.second};
  int banned = whoFirst.second;
  int cur = whoFirst.first;
  --ans;
  while (ans > 0) {
    assert(cur < n);
    bool ok = false;
    for (auto[nw, i] : graph[cur]) {
      if (nw == n) {
        if (i != banned) {
          path.push_back(i);
          ok = true;
          break;
        }
        continue;
      }
      auto dpNW = dp[nw];
      int val = dpNW.getVal(banned);
      if (val + 1 == ans) {
        path.push_back(i);
        cur = nw;
        ok = true;
        break;
      }
    }
    assert(ok);
    --ans;
  }
  for (int x : path) {
    cout << x + 1 << ' ';
  }
  cout << "\n";
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int t; cin >> t;
  while (t--) solveTest();
  
  return 0;
}
