#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solveTest() {
  int n, m, k;
  cin >> n >> m >> k;
  vector<int> p(n);
  for (int& x : p) {
    cin >> x;
    --x;
  }
  vector<int> posP(n);
  for (int i = 0; i < n; ++i) {
    posP[p[i]] = i;
  }
  vector<int> a(m);
  for (int& x : a) {
    cin >> x;
    --x;
    if (x >= 0) {
      x = posP[x];
    }
  }

  int const INF = int(1e9);
  vector<int> minEnd(m, INF);
  for (int i = 0; i < m; ++i) {
    if (a[i] == 0) {
      int j = i;
      while (j < m && a[j] == j - i) {
        ++j;
      }
      if (j - i == n) {
        minEnd[i] = j;
      }
    }
  }
  for (int i = m - 2; i >= 0; --i) {
    minEnd[i] = min(minEnd[i], minEnd[i + 1]);
  }
  vector<int> lenMatch(m);
  for (int i = m - 1; i >= 0; --i) {
    if (a[i] < 0) {
      lenMatch[i] = 0;
    } else {
      lenMatch[i] = 1;
      if (i + 1 < m && a[i + 1] == a[i] + 1) {
        lenMatch[i] += lenMatch[i + 1];
      }
    }
  }
  vector<int> lenMatchLeft(m);
  for (int i = 0; i < m; ++i) {
    if (a[i] < 0) {
      lenMatchLeft[i] = 0;
    } else {
      lenMatchLeft[i] = 1;
      if (i - 1 >= 0 && a[i - 1] == a[i] - 1 && a[i - 1] >= 0) {
        lenMatchLeft[i] += lenMatchLeft[i - 1];
      }
    }
  }

  struct edge {
    int to;
    int id;
  };
  vector<vector<edge>> graph(n + 1);
  auto addEdge = [&](int from, int to, int id) {
    graph[from].push_back({to, id});
  };
  vector<tuple<int, int, int>> doubleEdges;
  vector<pair<int, int>> ranges(k);
  for (auto& [l, r] : ranges) {
    cin >> l >> r;
    --l;
  }
  for (int it = 0; it < k; ++it) {
    auto[l, r] = ranges[it];
    if (minEnd[l] <= r) {
      cout << 1 << "\n";
      cout << it + 1 << "\n";
      return;
    }

    //  check substring
    int len = r - l;
    assert(len > 0);
    if (lenMatch[l] >= len) {
      addEdge(a[l], a[r - 1] + 1, it);
      continue;
    }
      
    //  check suffix 
    vector<tuple<int, int, int>> edges; 
    if (a[l] >= 0 && lenMatch[l] >= n - a[l]) {
      edges.emplace_back(a[l], n, it);
    }
    
    //  check prefix
    if (a[r - 1] >= 0 && lenMatchLeft[r - 1] > a[r - 1]) {
      edges.emplace_back(0, a[r - 1] + 1, it);
    }

    if (edges.size() < 2) {
      for (auto[u, v, i] : edges) {
        addEdge(u, v, i);
      }
    } else {
      for (auto[u, v, i] : edges) {
        doubleEdges.emplace_back(u, v, i);
      }
    }
  }
  vector<int> dpS(n + 1, INF);
  vector<pair<int, int>> parS(n + 1, make_pair(-1, -1));
  dpS[0] = 0;
  for (int v = 0; v < n; ++v) {
    for (auto[u, i] : graph[v]) {
      if (dpS[v] + 1 < dpS[u]) {
        dpS[u] = dpS[v] + 1;
        parS[u] = {v, i};
      }
    }
  }
  vector<int> dpT(n + 1, INF);
  vector<pair<int, int>> parT(n + 1, make_pair(-1, -1));
  dpT[n] = 0;
  for (int v = n - 1; v >= 0; --v) {
    for (auto[u, i] : graph[v]) {
      if (dpT[u] + 1 < dpT[v]) {
        dpT[v] = dpT[u] + 1;
        parT[v] = {u, i};
      }
    }
  }
  int ans = dpS[n];
  tuple<int, int, int> usedEdge{-1, -1, -1};
  for (auto[u, v, i] : doubleEdges) {
    if (u == 0) {
      if (dpT[v] + 1 < ans) {
        ans = dpT[v] + 1;
        usedEdge = {u, v, i};
      }
    } else {
      assert(v == n);
      if (dpS[u] + 1 < ans) {
        ans = dpS[u] + 1;
        usedEdge = {u, v, i};
      }
    }
  }
  if (ans == INF) {
    cout << -1 << "\n";
    return;
  }
  cout << ans << "\n";
  if (get<0>(usedEdge) < 0) {
    vector<int> path;
    int cur = n;
    while (cur > 0) {
      path.push_back(parS[cur].second);
      cur = parS[cur].first;
    }
    reverse(path.begin(), path.end());
    for (int x : path) cout << x + 1 << " ";
    cout << "\n";
  } else if (get<0>(usedEdge) == 0) {
    int cur = get<1>(usedEdge);
    vector<int> path{get<2>(usedEdge)};
    while (cur < n) {
      path.push_back(parT[cur].second);
      cur = parT[cur].first;
    }
    for (int x : path) cout << x + 1 << " ";
    cout << "\n";
  } else {
    assert(get<1>(usedEdge) == n);
    int cur = get<0>(usedEdge);
    vector<int> path{get<2>(usedEdge)};
    while (cur > 0) {
      path.push_back(parS[cur].second);
      cur = parS[cur].first;
    }
    reverse(path.begin(), path.end());
    for (int x : path) cout << x + 1 << " ";
    cout << "\n";
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int t; cin >> t;
  while (t--) solveTest();
  
  return 0;
}
