#include <bits/stdc++.h>

using namespace std;

struct point {
    long long x, y;
    point() {}
    point(long long x, long long y) : x(x), y(y) {}
};

vector<pair<long long, long long>> d{{1, 0}, {0, 1}, {-1, 0}, {0, -1}, {-1, -1}, {1, 1}, {-1, 1}, {1, -1}};

struct line {
    long long a, b, c;
    line(long long a, long long b, long long c) : a(a), b(b), c(c) {}
    line(point p1, point p2) : a(p1.y - p2.y), b(p2.x - p1.x), c(p1.x * p2.y - p2.x * p1.y) {}

    double distance(point p) {
        return abs(a * p.x + b * p.y + c) / sqrt(a * a + b * b);
    }
};

const long long MAX_COORD = 1e9;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

double solve(point p1, vector<point> points, long long x, long long y) {
    line l(p1, point(x, y));
    double dist = 0;
    for (int i = 0; i < points.size(); i++) {
        dist += l.distance(points[i]);
    }
    return dist;
}

long long cord(long long c) {
    return max(-MAX_COORD, min(c, MAX_COORD));
}


pair<double, pair<long long, long long>>  solve(point p1, vector<point> points) {
    long long x = rnd() % (2 * MAX_COORD + 1) - MAX_COORD;
    long long y = rnd() % (2 * MAX_COORD + 1) - MAX_COORD;
    double ans = solve(p1, points, x, y);
    int step = 1e8;
    double alp = 0.999;
    for (int iter = 0; iter < 3e5; iter++) {
        int nx, ny;
        double cur = solve(p1, points, x, y);
        for (int dir = 0; dir < 9; dir++) {
            int cx = cord(x + d[dir].first * step);
            int cy = cord(y + d[dir].second * step);
            double cand = solve(p1, points, cx, cy);
            if (cand < cur) {
                nx = cx;
                ny = cy;
                cur = cand;
            }
        }
        step = max((int)(alp * step), 1);
        x = nx;
        y = ny;
        ans = cur;
    }
    return {ans, {x, y}};
}

int main() {
    vector<point> points(3);
    for (int i = 0; i < 3; i++) {
        cin >> points[i].x >> points[i].y;
    }
    auto [d1, r1] = solve(points[0], points);
    auto [d2, r2] = solve(points[1], points);
    auto [d3, r3] = solve(points[2], points);
    cerr.precision(20);
    cerr << fixed << d1 << " " << d2 << " " << d3 << endl;
    if (d1 <= d2 && d1 <= d3) {
        cout << points[0].x << " " << points[0].y << " ";
        cout << r1.first << " " << r1.second << endl;
    } else if (d2 <= d1 && d2 <= d3) {
        cout << points[1].x << " " << points[1].y << " ";
        cout << r2.first << " " << r2.second << endl;
    } else if (d3 <= d1 && d3 <= d2) {
        cout << points[2].x << " " << points[2].y << " ";
        cout << r3.first << " " << r3.second << endl;
    }
}
