#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define nl endl

struct lichao{
    struct node{
        ld k = 0, b = LDBL_MAX;
        int l = -1, r = -1;

        node() = default;

        node(ld k, ld b) : k(k), b(b) {}
    };

    int sz = 0, root = -1;
    vector<node> t;
    int new_node(ld k = 0, ld b = LDBL_MAX){
        t[sz] = {k, b};
        return sz++;
    }

    lichao() {
        t.resize(2e7);
    }

    int add(int v, ll l, ll r, ld k, ld b){
        if (v == -1) return new_node(k, b);
        ll m = (l + r) / 2;
        if (t[v].k * m + t[v].b > k * m + b) swap(t[v].k, k), swap(t[v].b, b);
        if (r - l == 0) return v;
        if (l * k + b < t[v].k * l + t[v].b) t[v].l = add(t[v].l, l, m, k, b);
        if (r * k + b < t[v].k * r + t[v].b) t[v].r = add(t[v].r, m + 1, r, k, b);
        return v;
    }

    void add(ld k, ld b){
        root = add(root, 0, 1e18, k, b);
    }

    ld get(int v, ll l, ll r, ll x) {
        if (v == -1) return LDBL_MAX;
        ll m = (l + r) / 2;
        if (x <= m) return min(t[v].k * x + t[v].b, get(t[v].l, l, m, x));
        else return min(t[v].k * x + t[v].b, get(t[v].r, m + 1, r, x));
    }

    ld get(ll x) {
        return get(root, 0, 1e18, x);
    }
};

int main() {
    ll n, m, c;
    cin >> n >> m >> c;
    vector<ll> x(n + 2), t(n + 2);
    x[n + 1] = m;
    for(int i = 0; i < n; i ++) cin >> x[i + 1] >> t[i + 1];
    lichao lc;
    lc.add(0, 0);
    ld best;
    for(int i = 0; i <= n; i++) {
        best = (ld)(1) * x[i + 1] * x[i + 1] / c + lc.get(x[i + 1]);
        lc.add((ld)(1) * -2 * x[i + 1] / c, (ld)(1) * x[i + 1] * x[i + 1] / c + best + t[i + 1]);
    }
    cout << fixed << setprecision(15) << best << nl;
}
