#include <iostream>

using namespace std;

struct vec2
{
	double x, y;
};

template<typename t>
t mod(t x)
{
	return x > 0 ? x : -x;
}

template<typename t>
t min(t x, t y)
{
	return x > y ? y : x;
}

int main(void)
{
	double x1, x2, x3, y1, y2, y3, dx = 0, dy = 0, x_m, y_m, x_m1, y_m1;
	double l_min = INFINITY;

	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

	vec2 pairs[3] =
		{
			{x1, y1},
			{x2, y2},
			{x3, y3},
		};

	for (int i = 0; i < 3; i++)
	{
		int idx_2 = (i + 1) % 3,
			idx_3 = (i + 2) % 3;

		dx = pairs[i].x;
		dy = pairs[i].y;

		vec2 p2 = { pairs[idx_2].x - dx, pairs[idx_2].y - dy },
			p3 = { pairs[idx_3].x - dx, pairs[idx_3].y - dy };

		double ln = sqrt(p2.x * p2.x + p2.y * p2.y);

		vec2 l = { p2.x / ln, p2.y / ln };

		double lp2 = mod(l.x * p3.y - l.y * p3.x);

		ln = sqrt(p3.x * p3.x + p3.y * p3.y);

		l = { p3.x / ln, p3.y / ln };

		double lp3 = mod(l.x * p2.y - l.y * p2.x);

		if (lp2 < l_min)
		{
			x_m = pairs[i].x;
			y_m = pairs[i].y;

			x_m1 = pairs[idx_2].x;
			y_m1 = pairs[idx_2].y;

			l_min = lp2;
		}

		if (lp3 < l_min)
		{
			x_m = pairs[i].x;
			y_m = pairs[i].y;

			x_m1 = pairs[idx_3].x;
			y_m1 = pairs[idx_3].y;

			l_min = lp3;
		}
	}

	cout << x_m << " " << y_m << " " << x_m1 << " " << y_m1 << endl;

	return 0;
}