//
// Created by sch on 17.11.2024.
//
#include<bits/stdc++.h>
using namespace std;

#define ld   long double
#define int long long

struct point{
    ld x, y;
    point(ld x, ld y) {
        this->x = x;
        this->y = y;
    }
};

struct vect{
    ld x, y;
    vect(point a, point b) {
        this->x = b.x - a.x;
        this->y = b.y - a.y;
    }
    vect(ld x, ld y) {
        this->x = x;
        this->y = y;
    }
};

ld operator * (const vect& a, const vect& b) {
  return (a.x * a.x + a.y * b.y);
}

vect operator * (const vect& a, ld c) {
    return vect(a.x * c, a.y * c);
}

vect operator + (const vect& a, const vect& b) {
    return vect(a.x + b.x, a.y + b.y);
}

ld dist(vect a) {
    return sqrt(a.x * a.x + a.y * a.y);
}

vect norm(vect a) {
    vect ans = vect(-a.y, a.x);
    ans = ans * (1 / sqrt(a.x * a.x + a.y * a.y));
    return ans;
}

ld dist2(vect a) {
    return a.x * a.x + a.y * a.y;
}

point tring(point a, point b, ld x, ld y) {
    vect v = vect(a, b);
    ld len_v = dist(v);
    ld t = x * x - y * y;
    ld len_res = t / (2 * len_v) + len_v / 2;
    vect new_v = v * (len_res / len_v);
    ld new_l = sqrt(x * x - len_res * len_res);
    vect norm_v = norm(new_v) * new_l;
    vect res = norm_v + new_v;
    return point(a.x + res.x, a.y + res.y);
}

signed main(){
    cout << setprecision(15) << fixed;
    ld x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;
    point st = point(x0, y0);
    point fn = point(x1, y1);
    int n;
    cin >> n;
    vector<ld> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ld> prefmax(n + 1);
    vector<ld> prefsum(n + 1);
    prefmax[1] = a[n - 1];
    prefsum[1] = a[n - 1];
    for (int i = 2; i < n + 1; ++i) {
        prefmax[i] = max(prefmax[i - 1], a[n - i]);
        prefsum[i] = prefsum[i - 1] + a[n - i];
    }
    if (2 * max(prefmax[n], dist(vect(st, fn))) > prefsum[n] + dist(vect(st, fn))) {
        cout << "Impossible";
        exit(0);
    }
    cout << "Possible" << endl;
    ld cur = dist(vect(st, fn));
    point strt = point(x0, y0);
    point fnsh = point(x1, y1);
    for (int i = 0; i < n - 1; ++i) {
        ld maxlen = a[i] + cur;
        ld minlen = abs(cur - a[i]);
        cur = min(max(prefmax[n - i], cur), cur + a[i]);
        strt = tring(strt, fnsh, a[i], cur);
        cout << strt.x << " " << strt.y << endl;
    }
    cout << fnsh.x << " " << fnsh.y;
}