#include <algorithm>
#include <chrono>
#include <cmath>
#include <iostream>
#include <random>
#include <set>
#include <string>
#include <vector>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

#include <complex>

using C = long long;
using P = complex<C>;

#define X real()
#define Y imag()

C dot(P a, P b) {return (conj(a) * b).X;}
C cross(P a, P b) {return (conj(a) * b ).Y;}

struct line {
    P v;
    C c;
    line(P a, P b) : v(b-a), c(cross(v, a)) {}
    C side( P p) {
        return cross(v, p) - c;
    }
    C dist(P p) {
        return abs(side(p)) / abs(v);
    }
};

istream &operator>>(istream &in, P &v) {
    C x, y;
    in >> x >> y;
    v = {x, y};
    return in;
}

bool operator<(P a, P b) {
    if (a.X == b.X) {
        return a.Y < b.Y;
    }
    return a.X < b.X;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    P a, b, c;
    cin >> a >> b >> c;

//    C ans = min({line(a, b).dist(c), line(a, c).dist(b), line(b, c).dist(a),});


    P u = a, v = b;

    for (auto op1 : {a, b, c}) {
        for (auto op2 : {a, b, c}) {
            if (abs(op1 - op2) > abs(u - v)) {
                u = op1;
                v = op2;
            }
        }
    }




    cout << u.X << ' ' << u.Y << '\n';
    cout << v.X << ' ' << v.Y << '\n';

    return 0;
}
