#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct lf {

    lf() {}
    lf(ld k, ld b) : k(k), b(b) {}

    ld get(ld x) {
        return k * x + b;
    }

    ld k, b;

};

ld intersect(lf a, lf b) {
    return (b.b - a.b) / (a.k - b.k);
}

struct cht {

    cht() {
        v = {lf(0, 0)};
        p = {-1e18};
    }

    void add(lf f) {
        while (v.size() >= 2 && intersect(v[v.size() - 2], f) <= p.back()) {
            v.pop_back();
            p.pop_back();
        }
        p.push_back(intersect(v.back(), f));
        v.push_back(f);
    }

    ld get(ld x) {
        int pos = lower_bound(p.begin(), p.end(), x) - p.begin() - 1;
        return v[pos].get(x);
    }

    vector<lf> v;
    vector<ld> p;

};

void solve() {
    int n, m, c;
    cin >> n >> m >> c;
    vector<int> x(n), t(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> t[i];
    }
    x.insert(x.begin(), 0);
    t.insert(t.begin(), 0);
    x.push_back(m);
    t.push_back(0);
    n += 2;

    vector<ld> dp(n);
    dp[0] = 0;
    cht ch;
    for (int i = 1; i < n; i++) {
        dp[i] = ch.get(x[i]) + (ld)x[i] * x[i] / c + t[i];
        ch.add(lf(-2 * (ld)x[i] / c, dp[i] + (ld)x[i] * x[i] / c));
    }

    cout << dp.back();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(9) << fixed;

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}