#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

using ld = long double;

struct vec {
	ld x;
	ld y;
	vec(ld x1, ld y1) {
		x = x1;
		y = y1;
	}
};

struct line {
	ld a, b, c;
	line(vec A, vec B) {
		a = A.y - B.y;
		b = B.x - A.x;
		c = A.x * B.y - A.y * B.x;
	}
	ld dist(vec A) {
		return abs(a * A.x + b * A.y + c) / sqrt(a * a + b * b);
	}
};

int main() {
	ld x1, x2, x3, y1, y2, y3;
	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
	vec A(x1, y1);
	vec B(x2, y2);
	vec C(x3, y3);
	ld da = line(B, C).dist(A);
	ld db = line(A, C).dist(B);
	ld dc = line(B, A).dist(C);
	if (da <= db && da <= dc) {
		cout << B.x << ' ' << B.y << ' ' << C.x << ' ' << C.y;
	} else if (db <= da && db <= dc) {
		cout << A.x << ' ' << A.y << ' ' << C.x << ' ' << C.y;
	} else if (dc <= db && dc <= da) {
		cout << A.x << ' ' << A.y << ' ' << B.x << ' ' << B.y;
	}
}