#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;
//#define int long long
typedef long long ll;
typedef long double ld;

ld EPS = 0.000001;
ld pi = 3.14159265358979323846;

struct point {
    ld x, y;

    point(ld x1, ld x2) {
        x = x1;
        y = x1;
    }

    point() {
        x = 0;
        y = 0;
    }

    point operator+(point b) {
        return point(x + b.x, y + b.y);
    }

    point operator-(point b) {
        return point(x - b.x, y - b.y);
    }

    void norm() {
        ld q = sqrtl(x * x + y * y);
        x /= q;
        y /= q;
    }
};

struct line {
    ld a, b, c;

    line(point q, point w) {
        a = w.y - q.y;
        b = q.x - w.x;
        c = a * q.x + b * q.y;
        c *= -1;
    }

    line() {
        a = 0;
        b = 0;
        c = 0;
    }

    line(ld q, ld w, ld e) {
        a = q;
        b = w;
        c = e;
    }
};

ld distpl(point a, line b) {
    return abs((a.x * b.a + a.y * b.b + b.c) / sqrtl(b.a * b.a + b.b * b.b));
}

ld dist2(point a, point b) {
    return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

ll dist(point a, point b) {
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

point operator*(point a, ld x) {
    return point(a.x * x, a.x * x);
}

line findserper(point a, point b) {
    line ab(a, b);
    line p1;
    p1.a = -ab.b;
    p1.b = ab.a;
    p1.c = ((a + b) * 0.5).x * p1.a + ((a + b) * 0.5).y * p1.b;
    p1.c *= -1;
    return p1;
}

point pov(point a, ld angle) {
    point b;
    b.x = a.x * cosl(angle) - a.y * sinl(angle);
    b.y = a.x * sinl(angle) + a.y * cosl(angle);
    return b;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);
    point start, finish;
    cin >> start.x >> start.y >> finish.x >> finish.y;
    ll n;
    cin >> n;
    vector<ll> arr(n);
    ld mx = dist(finish, start), sum = dist(finish, start);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        mx = max(mx, (ld) arr[i]);
        sum += arr[i];
    }
    if (sum < mx * 2 - EPS) {
        cout << "Impossible";
        return 0;
    }
    if (dist(start, finish) - EPS > (ld) sum) {
        cout << "Impossible";
        return 0;
    }
    if (sum == mx * 2) {
        cout << "Possible\n";
        point ind = start;
        point dir = finish - start;
        dir.norm();
        for (int i = 0; i < n; ++i) {
            if (arr[i] == mx) {
                ind = ind + (dir * arr[i]);
            } else {
                ind = ind - (dir * arr[i]);
            }
            cout << ind.x << " " << ind.y << "\n";
        }
        return 0;
    }
    if (abs(sum - dist(start, finish)) < EPS) {
        cout << "Possible\n";
        point ind = start;
        point dir = finish - start;
        dir.norm();
        for (int i = 0; i < n; ++i) {
            ind = ind + (dir * arr[i]);
            cout << ind.x << " " << ind.y << "\n";
        }
        return 0;
    }

    ld l = dist(finish, start) / 2;
    ld r = 1000000000;
    ld mid;
    for (int _ = 0; _ < 100; ++_) {
        mid = (r + l) / 2;
        ld angle = asinl(dist(start, finish) / mid / 2) * 2;
        for (int i = 0; i < n; ++i) {
            angle += asinl(arr[i] / mid / 2) * 2;
        }
        if (angle < pi * 2) {
            r = mid;
        } else {
            l = mid;
        }
    }
    bool flag = false;
    {
        mid = l;
        ld angle = asinl(dist(start, finish) / mid / 2) * 2;
        for (int i = 0; i < n; ++i) {
            angle += asinl(arr[i] / mid / 2) * 2;
        }
        if (abs(angle - 2 * pi) < EPS) {
            flag = true;
        }
    }
    if (flag) {
        cout << "Possible\n";
        //line serp = findserper(finish, start);
        point dir = finish - start;
        dir.norm();
        swap(dir.x, dir.y);
        dir.x *= -1;
        dir = dir * sqrtl((dist2(finish, start) / 4) + l * l);
        dir = dir + (start + finish) * 0.5;
        mid = l;
        ld angle = asinl(dist(start, finish) / mid / 2) * 2;

        for (int i = 0; i < n; ++i) {
            angle += asinl(arr[i] / mid / 2) * 2;
        }
        if (abs(angle - 2 * pi) < EPS) {
            flag = true;
        }
    }
    return 0;
}

/*

4 100 25
10 50
15 30
50 100
80 60

*/
